<!doctype html>
<html>
<head>
  <link rel="stylesheet" href="file:///android_asset/style.css" />
</head>
  <body>
  <h2>Environnement de développement</h2>
 Dans cette partie, l'environnement de développement est abordée selon les quatres
 points :
 <ul>
   <li>Langage Java, Kotlin ou C/C++</li>
   <li>Android Studio</li>
   <li>SDK Android</li>
   <li>Déploiement</li>
 </ul>
  <h3>Langage Java, Kotlin ou C/C++</h3>
  <p>Le langage <i>Kotlin</i> a été officiellement annoncé comme étant le langage
  à utiliser dans les développements <i>Android</i>, le 17 mai 2017, à la
  <i>Google IO</i>.<br>
  Tout d'abord, <i>Kotlin</i> est un langage de programmation orienté objet (POO)
  et fonctionnel alors que <i>Java</i> est seulement un langage de POO.<br>
  <i>Kotlin</i> est le nom d'une île proche de Saint Pétersbourg, la ville où
  est basée l’équipe de <i>JetBrains</i> impliquée dans le développement de ce
  langage. Cette société a également développé l'<i>IDE</i> (<i>Integrated
  Development Environment</i>) <i>IntelliJ</i>, sur lequel est basé
  <i>Android Studio</i>.<br>
  En bref, voici quelques unes des vertues de <i>Kotlin</i> :
  <ul>
    <li>Langage peu verbeux : pas de <code>;</code> </li>
    <li>Langage clair et concis : pas de <code>getter/setter</code> (accès direct aux attributs)</li>
    <li>Affranchissement du <code>NullPointerException</code> : rien n'est nulle </li>
    <li>Interpollation de chaines de charactère : <code>Log.i(TAG, "my width is $mWidth")</code></li>
    <li>Déclaration de variables simplifiée : soit <code>val</code> soit <code>var</code></li>
    <li>Conversion de type automatique : <code>val mWidth = 0</code></li>
  </ul>
  </p>
  <p>Concrètement, afin de tester en direct le langage <i>Kotlin</i>, il suffit
  de se rendre dans la partie <i>TRY</i> du
  <a href="https://try.kotlinlang.org">site officiel</a>.
  Puis, des exercices ludiques sont disponibles, dans la partie <i>Kotlin Koans</i>.</p>
  <p>Le choix du langage <i>Java</i>, <i>Kotlin</i>, <i>C</i> ou <i>C++</i>
  n'est pas une question de préférence personnelle.<br>
  D'une part, le choix entre le langage <i>Java</i> et <i>Kotlin</i> dépend des
  compétences de l'équipe de développement (ou de sa volonté à s'adapter et de se
  former sur une nouvelle technologie). Dans tous les cas, ces deux langages sont
  les plus couramment utilisés dans le développement d'application <i>Android</i>.<br>
  D'autre part, le choix du langage <i>C</i> ou <i>C++</i> est décidé pour avoir
  accès à des bibliothèques existantes d'ores et déjà écrites dans ces langages.
  De plus, ils peuvent être privilégiés afin d'avoir accès à plus de performances
  pour des traitements intensifs (simulation physique).
  Ils s'utilisent avec le <i>NDK</i>, accronyme de <i>Native Development Kit</i>,
  soit boîte à outils de développement natif.</p>

  <h3>Android Studio</h3>
  <p>Le logiciel <i>Android Studio</i> est télechargeable à partir du site officiel
  <a href="https://developer.android.com/studio/">developper.android.com</a>.
  L'installation de ce dernier se déroule en deux étapes :
  <ol>
    <li>Installation du logicel</li>
    <li>Téléchargement des dernières versions <i>Android</i></li>
  </ol>
  </p>
  <p>Une fois l'<i>IDE</i> installé, il s'agit de télécharger les dernières versions
  d'<i>Android</i>. En particulier, il s'agit de télécharger via <i>Android Studio</i>,
  les <i>SDK</i> (<i>System Development Kit</i> soit boîte à outils de dévelopement)
  relatifs aux dernières versions <i>Android</i>.</p>
  <p><i>Android Studio</i> permet de :
  <ul>
    <li>Créer un nouveau projet</li>
    <li>Ouvrir un projet existant</li>
    <li>Récupérer un projet depuis un gestionnaire de version (GIT, SVN)</li>
    <li>Importer un projet Android (créé avec un autre environement, par exemple avec <i>Eclipse</i>)</li>
    <li>Importer un exemple de projet <i>Android</i></li>
    <li>Configurer le <i>SDK</i>, les Préférences, ajouter des <i>Plugins</i>
(extensions)</li>
  </ul></p>
  <p>Dans un projet <i>Android Studio</i>, l'application est construite avec le
  système de fichiers <i>Gradle</i> similaire à <i>Maven</i> ou <i>Ant</i>.</p>
  <p>En particulier, les <u>fichiers <i>Gradle</i></u> permettent de gérer le projet
  ainsi que de construire l'exécutable de l'application : <i>APK</i>
  (<i>Android Application Package</i>).<br>
  Plus généralement, ils permettent de :
  <ul>
    <li>personnaliser et configurer le processus de compilation</li>
    <li>créer plusieurs <i>APK</i> selon différentes configurations (test, production, etc.)</li>
    <li>gérer les dépendances et bibliothèques utilisées</li>
    <li>spécifier le numéro et le nom de la version de l'application</li>
  </ul>
  </p>

  <h3>SDK Android</h3>
  <p>Le <i>SDK Android</i> est l'outil indispensable pour créer une application
  <i>Android</i>.
  Chaque version <i>Android</i> possède un <i>SDK</i> (cf. Historique dans
  Plateforme Android).<br>
  Le <i>SDK Android</i> contient les éléments suivants :
  <ul>
    <li><i>aapt</i> (<i>Android Asset Packaging Tool</i>), sert à créer et analyser
  des fichies <i>APK</i>.</li>
    <li><i>adb</i> (<i>Android Debug Bridge</i>), sert à établir des connexions avec
  un appareil <i>Android</i> ou un émulateur, cela en facilitant l'accès à leur
  <i>shell</i>, de cette façon il est possible de parcourir le contenu de l'appareil,
  d'éxecuter des commandes, de transférer des applications ou des fichiers.</li>
    <li><i>ddms</i> (<i>Dalvik Debug Monitor Server</i>), sert au débogage de
  l'application et à faire des captures d'écran, voir les processus en cours d'exécution
  voir la console des messages d'erreur, simuler l'envoi de messages et d'appels,
  simuler une position <i>GPS</i>, etc.</li>
    <li>Système d'émulateur</li>
    <li>Projets exemples</li>
  </ul>
  </p>
  <p>Le <i>SDK Android</i> se configure via <i>Android Studio</i>. Plus précisément,
  via le gestionnaire du <i>SDK Android</i> soit <i>Android SDK Manager</i>.
  Il permet de :
  <ul>
    <li>télécharger le <i>SDK</i> des dernières versions d'<i>Android</i></li>
    <li>mettre à jour le <i>SDK</i> de versions déjà téléchargées</li>
  </ul>
  </p>
  <p>Afin de voir les détails de téléchargement, il est possible de cocher <i>Show Package
  Details</i> du volet <i>SDK Platforms</i>. Les lignes contenant le mot clé
  <i>System Image</i> correspondent à des fabriques d'émulateurs.
  De plus, le volet <i>SDK Tools</i> présente les divers outils :
  <ul>
    <li><i>Android SDK Build-Tools</i></li>
    <li><i>Android SDK Platforms-Tools</i></li>
    <li><i>Android SDK Tools</i></li>
    <li><i>Android SDK Emulator</i></li>
    <li><i>Intel x86 Emulator Accelerator (HAXM installer)</i>, outils pour rendre l'émulateur plus rapide</li>
  </ul>
  </p>
  <p>Le champ <i>Android SDK Location</i> indique l'endroit où est installé le <i>SDK
  Android</i> sur l'ordinateur. Le dossier en question contient :
  <ul>
    <li><i>build-tools</i>, les outils dont ceux pour créer une application</li>
    <li><i>emulator</i>, les émulateurs créés</li>
    <li><i>extras</i>, les outils téléchargés</li>
    <li><i>platforms-tools</i>, les outils permettant de développer et déboger les applications</li>
    <li><i>platforms</i>, les différentes versions de <i>SDK</i> téléchargées, organisées par numéro de version</li>
    <li><i>skins</i>, les façades des émulateurs</li>
    <li><i>system-images</i>, les fabriques d'émulateur</li>
    <li><i>tools</i>, les outils facilitant l'utilisation du <i>SDK Android</i></li>
  </ul>
  </p>
  <h3>Déploiement</h3>
  <p>Dans le but de voir le résultat d'un projet <i>Android</i>, il est possible
  d'exécuter ce dernier, c'est-à-dire de le déployer sur un émulateur d'<i>Android
  Studio</i> ou bien sur un appareil physique.</p>
   <p><i>Android Studio</i> donne l'oportunité de simuler différents appareils
   en termes de :
   <ul>
    <li>type d'apareils (téléphone, tablette)</li>
    <li>type de téléphone (Nexus, Galaxy )</li>
    <li>taille d’écrans (résolutions)</li>
    <li>version d'Android</li>
   </ul>
   </p>
<h4>Partie suivante</h4>
<a href="file:///android_asset/1C-principeprogrammation.html">Principes de
programmation</a>
   <h4>À faire</h4>
    <a href="https://www.chillcoding.com/blog/2016/08/03/android-studio-installation/">
    Installer un environnement de développement Android</a>
  </body>
</html>
